
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Linux下进程的创建（system(); fork(); exec*()） / 憋错料</title>

    <meta name="description" content="Linux下进程的创建（system(); fork(); exec*()） 0. system(); system()函数通过调用shell程序来执行所指向的命令(效率低),相当于先fork(),再execve(): 特点:原进程和子进程各自运行,且原进程需要等子进程运行完后再继续: 1. fork(); 参考文献: linux中fork同时创建多个子进程的方法(一) 在Linux中用fork()由一个父进程创建同时多个子进程的格式如下: 1 int status,idx; 2 3 for (idx = 0; idx &lt; 10; idx++) { 4 status ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Linux下进程的创建（system(); fork(); exec*()）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>0. system();</p>
<p>system()函数通过调用shell程序来执行所指向的命令（效率低），相当于先fork()，再execve()；</p>
<p>特点：原进程和子进程各自运行，且原进程需要等子进程运行完后再继续；</p>

<p>1. fork();</p>
<p>参考文献： <a href="http://blog.sina.com.cn/s/blog_605f5b4f0100x444.html" rel="external nofollow noreferrer">linux中fork同时创建多个子进程的方法（一）</a></p>
<p>在Linux中用fork()由一个父进程创建同时多个子进程的格式如下：</p>
<pre> 1 int status,idx;
 2
 3 for (idx = 0; idx &lt; 10; idx++) {
 4   status = fork();
 5   if (status == 0 || status == -1) break;  // 每次循环时，如果发现是子进程就直接从创建子进程的循环中跳出来，不让你进入循环，这样就保证了每次只有父进程来做循环创建子进程的工作
 6 }
 7
 8 if (status == -1) {
 9   //error
10 } else if (status == 0) {  // 每个子进程都会执行的代码
11   //sub process
12 } else {
13   //parent process
14 }</pre>
<p>参考文献：<a href="http://blog.csdn.net/kangear/article/details/8505409" rel="external nofollow noreferrer">进程控制：linux中fork同时创建多个子进程注意事项</a></p>
<pre>    /* 这里不可以一下就创建完子进程，要用
    *要 创建-》判断-》使用-》return or exit.更不能这样如test2.c
    *childpid1 = fork();
    *childpid2 = fork();
    *childpid3 = fork();
    */
    childpid1 = fork();                                             //创建
    if(0 == childpid1)                                              //判断
    {                                                               //进入
        printf("In child1 process\n");
        printf("\tchild pid = %d\n", getpid());
        exit(EXIT_SUCCESS);                                         //退出
    }  </pre>
<p>2. exec*();</p>
<p>参考文献：</p>
<p><a href="http://blog.sina.com.cn/s/blog_706f7a530101pul5.html" rel="external nofollow noreferrer">linux系统编程之进程（五）：exec系列函数</a></p>
<p><a href="http://www.2cto.com/os/201403/286164.html" rel="external nofollow noreferrer">Linux下execl学习</a></p>
<p>编译中出现的错误：</p>
<p>使用execl()函数时出现warning: not enough variables to fit a sentinel</p>
<p>解决方法 - <a href="http://stackoverflow.com/questions/3816778/not-enough-variables-to-fit-a-sentinel" rel="external nofollow noreferrer">调整execl中的参数</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 16:16:28 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Linux下进程的创建（system(); fork(); exec*()）的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dzD5e4.html" rel="bookmark">Linux下进程的创建过程分析&lpar;&lowbar;do&lowbar;fork&sol;do&lowbar;fork详解&rpar;--Linux进程的管理与调度（八）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				日期 内核版本 架构 作者 GitHub CSDN 2016-05-12 Linux-4.5 X86 &amp; arm gatieme LinuxDeviceDrivers Linux进程管理与调度-之-进程的创建 参照 分析Linux内核创建一个新进程的过程 前言 Unix标准的复制进程的系统调用时fork(即分叉),但是Linux,BSD等操作系统并不止实现这一个,确切的说linux实现了三个,fork,vfork,clone(确切说vfork创造出来的是轻量级进程,也叫线程,是共享资源的进程)			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kljrX3.html" rel="bookmark">《linux下进程的创建，执行，监控和终止》</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				http://blog.csdn.net/miss_acha/article/details/43671047 http://blog.csdn.net/rosekin/article/details/15341835 linux下用脚本实现:监控一个进程,不存在则将其启动. http://www.jb51.net/article/38099.htm linux下监视进程 崩溃挂掉后自动重启的shell脚本 http://www.cnblogs.com/zdz8207/p/3282352.htm			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3O2dNK0.html" rel="bookmark">Linux c进程管理&mdash;创建进程 system、execl、execlp、fork</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Linux c 进程管理:   1.      创建进程:        system函数:         int system(const char*filename);                                                  建立独立进程,拥有独立的代码空间,内存空间                                                  等待新的进程执行完毕,system才返回.(阻塞)          system:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wjxbl0.html" rel="bookmark">Linux进程的创建函数fork&lpar;&rpar;及其fork内核实现解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				进程的创建之fork() Linux系统下,进程可以调用fork函数来创建新的进程.调用进程为父进程,被创建的进程为子进程. fork函数的接口定义如下: #include &lt;unistd.h&gt; pid_t fork(void); 与普通函数不同,fork函数会返回两次.一般说来,创建两个完全相同的进程并没有太多的价值.大部分情况下,父子进程会执行不同的代码分支.fork函数的返回值就成了区分父子进程的关键.fork函数向子进程返回0,并将子进程的进程ID返给父进程.当然了,如果fork失败,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3O1DA9M.html" rel="bookmark">ASP&period;NET Core Linux下为 dotnet  创建守护进程（必备知识）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:ASP.NET Core Linux下为 dotnet 创建守护进程(必备知识) 前言 在上篇文章中介绍了如何在 Docker 容器中部署我们的 asp.net core 应用程序,本篇主要是怎么样为我们在 Linux 或者 macOs 中部署的 dotnet 程序创建一个守护进程,来保证我们的程序在异常或者是电脑重启的时候仍然能够正常访问. 如果你以后用准备使用 asp.net core来开发项目的话,程序并且部署到 Linux 上的话,那么此篇文章你值得收藏. 如果你觉得对你有帮助的话			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyeE8jM.html" rel="bookmark">Linux 下进程与线程的基本概念</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2019-10-01 关键字:进程.线程.信号量.互斥锁 什么是程序? 程序就是存放在磁盘上的指令和数据的有序集合,就是源代码编译产物. 它是静态的. 什么是进程? 进程就是操作系统为执行某个程序所分配的资源的总称.进程是程序的一次执行过程,因此它与程序不同,它是动态的.它的生命周期包括创建.调度.执行和消亡. 进程的内容主要包括以下三个部分: 1.正文段: 2.用户数据段: 3.系统数据段. 其中正文段与用户数据段两部分是从程序当中来的.而系统数据段则是操作系统分配的用来管理这个进程用的. 系			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/V02qXnM.html" rel="bookmark">linux下shell脚本执行方法及exec和source命令</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				exec和source都属于bash内部命令(builtins commands),在bash下输入man exec或man source可以查看所有的内部命令信息. bash shell的命令分为两类:外部命令和内部命令.外部命令是通过系统调用或独立的程序实现的,如sed.awk等等.内部命令是由特殊的文件格式(.def)所实现,如cd.history.exec等等. 在说明exe和source的区别之前,先说明一下fork的概念. fork是linux的系统调用,用来创建子进程(child			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0ayZWQ0.html" rel="bookmark">【网络编程基础】Linux下进程通信方式（共享内存，管道，消息队列，Socket）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在网络课程中,有讲到Socket编程,对于tcp讲解的环节,为了加深理解,自己写了Linux下进程Socket通信,在学习的过程中,又接触到了其它的几种方式.记录一下. 管道通信(匿名,有名) 管道通信,在一个进程之中,只能单一的对其写或者是读,而不可以及执行写操作又执行读操作.这一点,我们可以将其想象成我们的水管,分别连着不同的两端,在有水流的时候,一端只能进行输入,另一端只能进行输出,而不可以同时输入和输出. 管道又分为有名管道和匿名管道,两者的区别在于对于匿名管道,其只能在具有亲缘关系的父			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0K1Bgj4.html" rel="bookmark">Linux下进程间Socket通信调试debug方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在一个复杂的软件系统中,往往需要有各个组件之间的数据传递,在组件间数据传递过程中,又会不可避免的出现一些小问题,这时候我们就需要来进行debug了,由于最近的一个系统使用到了collectd和rrdcached来收集数据和画图,它们之间采用了Unix socket通信,因此小小的学习了一下相关知识. 首先我们来回忆下Linux下进程通信有哪些方法: 管道(Pipe)及有名管道(FIFO)\UNIX BSD 信号(Signal) \UNIX BSD 报文消息队列(Message)\UNIX sys			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/kMLWDE4.html" rel="bookmark" class="title">多表查询</a>
					<div>
						范例1:查询emp表中的数据量 —— 14条数据 SELECT COUNT(*) FROM emp ;   范例2:查询dept表中的数据量 —— 4条数据 SELECT COUNT(*) FROM  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/B0R2N50.html" rel="bookmark" class="title">python切片</a>
					<div>
						假设有一个list,要对其进行截取操作 L = ['Michael', 'Smith', 'Jobs', 'John'] 首先分别取出其中的值,我们可以像PHP中操作数组一样取值 可见,此种方法可以取 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6N8KZM.html" rel="bookmark" class="title">&period;net 分布式架构之分布式锁实现</a>
					<div>
						分布式锁 经常用于在解决分布式环境下的业务一致性和协调分布式环境. 实际业务场景中,比如说解决并发一瞬间的重复下单,重复确认收货,重复发现金券等. 使用分布式锁的场景一般不能太多. 开源地址:http ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eqEn50.html" rel="bookmark" class="title">POJ 2240 Arbitrage &lpar;spfa判环&rpar;</a>
					<div>
						Arbitrage Arbitrage is the use of discrepancies in currency exchange rates to transform one unit of  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35bNwV4.html" rel="bookmark" class="title">初学react---todolist实例</a>
					<div>
						最近刚学习了阮一峰老师的react入门教学-----React 入门实例教程 然后大概理解了React的用法,然后比较迷茫不知道react可以干啥,看评论说先做个todolist,然后我就看着一些教程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MX7lLw4.html" rel="bookmark" class="title">window下Nodejs的部署</a>
					<div>
						nodejs http://nodejs.org/#download npm node cli.js install npm -gf //可以安装最新版的NPM node cli.js install ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bgLkV3.html" rel="bookmark" class="title">mysql  时间字段的函数 timestamp</a>
					<div>
						Mysql 里格式 时间字段的函数 DATE_FORMAT unix_timestamp - 墨墨修行的日志 - 网易博客http://jjuanxi.blog.163.com/blog/static ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/415EyY4.html" rel="bookmark" class="title">Servlet的使用方法详细说明</a>
					<div>
						Servlet的生命周期方法: init() destroy() doGet(HttpServletRequest request,HttpServletResponse response) 客户端请 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4J8BYB0.html" rel="bookmark" class="title">1&period;2Naming Conventions&colon; 命名约定</a>
					<div>
						Ember.js使用一个运行时解析器去连接你的对象而没有很多样板文件.作为一个开发者,如果你把code放到约定好的位置这个解析器会自动工作. 一.The Application      当你的app ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyKbBA3.html" rel="bookmark" class="title">第四次作业&mdash;&mdash;肖祥英</a>
					<div>
						解:(1)由于C(a)=1,C(b)=2,C(r)=3,C(t)=4,则: 序列 输出 &lt;0,0,3&gt; r &lt;0,0,1&gt; ra &lt;0,0,4&gt; rat &lt;2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0x57Gr3.html" rel="bookmark" class="title">设备驱动调试和移植的一般方法</a>
					<div>
						做linux底层软件工作也有两年了,算上研究生时期对底层软件的研究,加起来也快四年了.慢慢地发现有必要总结一些一般性的方法了.因为一般性的方法有宏观上的指导意义,以后调试和移植驱动时,经常性地回味这些 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/415lVk4.html" rel="bookmark" class="title">NYOJ  14  会场安排问题</a>
					<div>
						#include&lt;stdio.h&gt;#include&lt;string.h&gt;#include&lt;algorithm&gt;using namespace std;struct s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qa5L93.html" rel="bookmark" class="title">javascript事件之： 事件冒泡， 事件捕获 ，阻止默认事件</a>
					<div>
						谈起JavaScript的 事件,事件冒泡.事件捕获.阻止默认事件这三个话题,无论是面试还是在平时的工作中,都很难避免. 冒泡篇: 先来看一段实例: js: var $input = document ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02ZZ5R0.html" rel="bookmark" class="title">平板电脑离寿终正寝还有多远？</a>
					<div>
						近期有评论称,因为大尺寸智能手机越来越普及,小尺寸平板正遭受着越来越严重的冲击,在这样的背景下,平板厂商也纷纷转攻超大尺寸平板市场,以此避开大尺寸智能手机的竞争,只是.这样的策略转变是否能扭转平板电脑 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bqZr9M.html" rel="bookmark" class="title">owin 中间件 katana 如何解密cookie</a>
					<div>
						.NET MVC5 默认的用户登录组件是AspNet.Identity ,支持owin,并且微软自己实现的一套owin 中间件叫 katana 补充一下 katana项目源码地址:https://ka ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KOW5Y0.html" rel="bookmark" class="title">Codeforces Gym 100114 H&period; Milestones 离线树状数组</a>
					<div>
						H. Milestones Time Limit: 1 Sec Memory Limit: 256 MB 题目连接 http://codeforces.com/gym/100114 Descripti ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MV7mG10.html" rel="bookmark" class="title">SOYO的主板如何进入BIOS系统</a>
					<div>
						1 开机按Del键进入BIOS系统 2 进入Advanced BIOS Features 3 选择 Hard Disk Boot Priority 按ENTER 4 选择要启动的设备,比如USB-HD ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoLZjw0.html" rel="bookmark" class="title">Linux操作命令（一）</a>
					<div>
						su 英文解释:switch user 作用:切换当前登录的用户到其他用户. 使用方法:su [-l] username 实例: [[email protected] ~]# clear [[emai ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rBVjg3.html" rel="bookmark" class="title">JVM相关参数配置和问题诊断&amp;lt&semi;转&amp;gt&semi;</a>
					<div>
						原文连接:http://blog.csdn.net/chjttony/article/details/6240457 1.Websphere JVM相关问题诊断: 由JVM引起的Websphere问题 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0K8G2m3.html" rel="bookmark" class="title">XML快速入门</a>
					<div>
						XML是什么 Extensible Markup Language 自定义标签: 用来传输数据: 可扩展标记语言,是一种类似超文本标记语言的标记语言. 与HTML的比较: 1.不是用来替代HTML的: ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
